/*
	i2ctune.c  version 0.1 is to be used with cxadc.c driver to 
	tune tv tuner 
	  
    Copyright (c) 2005 Hew How Chee <how_chee@yahoo.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/
/*
History

    20 Sep 2005 - initial code
                - generally can tune the tuner
 		- but have problem sometimes after band switching
		- if keyed in frequency  does not seem to tune
		- try keying in 500 (for 500 Mhz) and go back to that
		- frequency again 

*/

#include        <stdio.h>
#include        <signal.h>
#include        <locale.h>
#include        <unistd.h>
#include        <limits.h>
#include        <stdlib.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/mman.h>

//scl is bit 1 , sda is bit 0


//fm freq 87.7  88.5  89.3  90.3  91.1 92.3  93.9   95.8  97.2   ...

#define WAIT100MS  {usleep(100000);}
#define WAIT10MS  {usleep(10000);}

#define SCL_HIGH {state|=2;setio(state,fd0);}
#define SCL_LOW  {state&=1;setio(state,fd0);}
#define SDA_HIGH {state|=1;setio(state,fd0);}
#define SDA_LOW  {state&=2;setio(state,fd0);}


void setio(unsigned int x,int dev)
{
	ioctl(dev,0x12345678,x);
}
void send4byte(unsigned int x,int swap)
{
	int fd0;

	unsigned char data[5];
	unsigned int state=3;
	unsigned char sft;
	int i,j;
//	FILE *fp;
//	fp=fopen("C:\\i2c.pcm","wb+");

	fd0 = open ("/dev/cxadc", O_RDWR);
 	if (fd0 < 0)
 	{	
 		printf ("open error");
 		return ;
	}
	data[0]=0xc0;
//	swap=1;
	if(!swap)
	{
		printf("not swap\n");
		data[1]=(x>>24)&0xff;
		data[2]=(x>>16)&0xff;
		data[3]=(x>>8)&0xff;
		data[4]=(x)&0xff;
	}
	else
	{
		printf("swap\n");
		data[3]=(x>>24)&0xff;
		data[4]=(x>>16)&0xff;
		data[1]=(x>>8)&0xff;
		data[2]=(x)&0xff;
	}

	//idle
	SCL_HIGH
	SDA_HIGH
	//SETIO
	WAIT100MS
	//start
	SDA_LOW
	//SETIO
	WAIT10MS
	for(i=0;i<5;i++)
	{
		sft=data[i];
		for(j=0;j<8;j++)
		{
			SCL_LOW
	//		SETIO
			WAIT10MS
			if(sft&0x80)
			{
				SDA_HIGH
			}
			else
			{
				SDA_LOW
			}
	//		SETIO
			WAIT10MS
			SCL_HIGH
	//		SETIO
			WAIT10MS
			sft<<=1;


		}
		SCL_LOW
	//	SETIO
		WAIT10MS
		//ack
		SDA_HIGH
		WAIT10MS
		SCL_HIGH
	//	SETIO
		WAIT10MS



	}
	SCL_LOW
	//SETIO
	WAIT10MS
	SDA_LOW
	//SETIO
	WAIT10MS
	SCL_HIGH
	WAIT10MS
	SDA_HIGH
	WAIT10MS
	close(fd0);
	
//	fclose(fp);	
}
int main()
{

	unsigned int val;
	float ifreq,freq=48.3;
	float oldfreq=-1.0;
	int swap=0;
	while(1)
	{
		printf("\nEnter radio station in Mhz (e.g. 87.7) :");
		scanf("%f",&freq);
		if((freq<48.25)||(freq >863.25)) 
		{
			freq=87.7;
			printf("freq out of range. default to 87.7\n");
		}

		//oldfreq=freq;
		ifreq=freq+10.7;
		ifreq*=20;
		val=ifreq+0.5;
		printf("val %d\n",val);
		val&=0xffff;
		val<<=16;
		//val|=0x88a6;
		val|=0x8800;
		if(freq<170) val|=0xa6;
		else if(freq>=170 && freq<=470) val|=0x96;
		else val|=0x36;
		
		if(oldfreq==-1)
		{
			swap=0;
			
		}
		else
		{
			if(freq>oldfreq)
			{
				swap=0;
			}
			else
			{
				swap=1;
			}
		}
		
		oldfreq=freq;

		printf("sending 0x%x %d %f\n",val,val>>16,((float)(val>>16))/20.0-10.7);
		send4byte(val,swap);
		//usleep(300000);
		//freq=oldfreq;
		///freq+=.5;
//		usleep(500000);
		freq+=0.1;
	}
	return 0;

}
